# 总体流程
该股票订阅告警系统的流程如图：
![股票订阅告警系统流程图](https://upload-images.jianshu.io/upload_images/10171495-7938c22771571d6a.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)


# 新手速配

> 需要服务号（具有模板消息推送权限）

1. 启动FutuOpenD

![OpenD启动成功](https://upload-images.jianshu.io/upload_images/10171495-6c42f94cca263d62.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

2. 配置参数
 
 公众号参数配置：
 
![基本配置](https://upload-images.jianshu.io/upload_images/10171495-dd195dbf8c7f43e9.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)
![APPID、Secret和IP白名单](https://upload-images.jianshu.io/upload_images/10171495-729aa1bf42f21ce4.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)


> 注意，上图的IP白名单一定要加上IP


配置微信公众号以及推送参数：
> Config.py
```
# wechat
self.appid = ''       # AppID
self.secrect = ''      # Secret

# server
self.token = ''   # token，该token与下一步填写的token应填写一致

# parameter
self.premium_rate = 0.005
self.warning_threshold = 1000000
self.large_threshold = 5000000
self.warning_limit = 5

# template_id
self.template_id = ""   # Template ID    想直接使用的情况下可以使用我们的模板"jr67sFJ5w4ln_ty6e0BHSBLZNOUOgMXOC-ph9u6xWwQ"

# sqlite
self.database = 'stock_alarm'

# FutuOpenD
self.host = '127.0.0.1'
self.port = 11111
```

3. 运行并使用

**先运行wx_service.py**，然后在公众号上配置URL和token并点击确认（URL格式如: http://test.app/wx_flask ，其中 http://test.app 为您的域名地址）。
运行了这个程序之后，即可在公众号配置参数。

![填写服务器设置](https://upload-images.jianshu.io/upload_images/10171495-fe8c77c4ce6f32ae.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/500)

成功会显示配置成功，配置失败请确认上述程序是否运行，以及域名和token填写是否正确。成功后即可操作如下：

![在公众号配置参数](https://upload-images.jianshu.io/upload_images/10171495-fb756683864546e2.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/500)

设置阈值后会按照阈值进行预警，如未填写阈值，则按照Config.py中的默认阈值进行预警。

4. 运行main.py
> main.py

可修改订阅的股票列表
```
big_sub_codes = ['HK.02318', 'HK.02828', 'HK.00939', 'HK.01093', 'HK.01299',
                'HK.00175',  'HK.01299', 'HK.01833', 'HK.00005', 'HK.00883',
                'HK.00388', 'HK.01398', 'HK.01114', 'HK.02800', 'HK.02018',
                'HK.03988', 'HK.00386', 'HK.01211', 'HK.00857', 'HK.01177',
                'HK.02601', 'HK.02628']
```
即可订阅逐笔，并且推送预警消息。程序运行结果：

![执行结果](https://upload-images.jianshu.io/upload_images/10171495-0248631e01b46731.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/500)

收到公众号消息：

![公众号预警消息](https://upload-images.jianshu.io/upload_images/10171495-a3f18f7eb0c927a5.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/400)

注意：使用的数据库是存储本地的（保存用户设置和价格），所以需要将wx_service.py和main.py运行在一个服务器上。

# 个人定制
各个模块的功能：

模块名 | 功能简述 |
---|---|
main.py | 该模块用于运行订阅推送 |
data_acquisition.py | 用于订阅逐笔 |
data_strategy.py | 包括检测逐笔消息、计算逐笔是否满足预警（预警策略）|
wx_push.py | 消息推送模块 |
Config.py | 参数配置 |
check_config.py | 参数检查模块 |
sqlite_interface.py | 数据库接口，包括增删改查 |
wx_service.py | 自动回复用户消息和修改配置的本地服务器 |

逐笔订阅、微信推送和自动回复等功能使用请参考附件1~3.